#include <bits/stdc++.h>

#define ull unsigned long long

ull qs[300001];
int mapa[300001] = { 0 };
ull psum[300001] = { 0 };

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);

    int N, Q;
    std::cin >> N >> Q;
    for(int i = 0; i < N; i++)
    {
        int dan, broj;
        std::cin >> dan >> broj;
        mapa[dan - 1] = 1;
        mapa[dan - 1 + broj] = -1;
    }
    for(int i = 0; i < Q; i++)
    {
        std::cin >> qs[i];
    }

    for(int i = 1; i < 300001; i++)
        mapa[i] += mapa[i - 1];

    psum[0] = mapa[0];
    for(int i = 1; i < 300001; i++)
        psum[i] = psum[i - 1] + mapa[i];
    
    for(int i = 0; i < Q; i++)
        std::cout << psum[qs[i] - 1] << "\n";

    return 0;
}